(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)



(* MrvLimit v1.0 (c) 2005 by Udo Richter           *)
(* mail:udo_richter(at)gmx.de                      *)
(* web:http://urichter.cjb.net/MrvLimit            *)
(* Released under the GNU General Public License.  *)
(* "$Id: MrvLimit.m 97 2005-05-11 00:57:18Z udo $" *)



BeginPackage["MrvLimit`"];

Off[General::spell1];
Off[General::spell];
{power,pwr,log,sin,cos,tan,arcsin,arccos,arctan,gamma,loggamma,polygamma,
    Output,output,direction,term,Limit,LeadTerm,SignedZero,Debug,Automatic,
    Direction,ClearCache,MrvLimitGetCacheStats,MrvLimitClearCache,CacheHits,
    CacheMisses,\[Omega],MrvF,MrvSeriesHead,$MrvSeriesHead,$DebugPrint,
    IndentPrint,MrvTestZero,$MrvTestZero,
    MrvTestZeroInterval,$MrvTestZeroInterval,$OutputProcessor,
    MrvLimitLoadSilent,Zero,FromInternal,ToInternal};
On[General::spell1];
On[General::spell];

ToInternal::usage=
    "ToInternal[f,x] translates f[x] to internal package form, making sure \
that no critical automatic transformations will be done on f any more. If \
ToInternal succeeds, return value will be free of ToInternal calls (check \
using FreeQ). If ToInternal fails, an UnsupportedFunction error is issued, \
and the failing ToInternal call will be encapsulated in HoldForm.";

FromInternal::usage=
    "FromInternal[f,x] translates internal representation of f[x] back to \
general Mathematica representation. See ToInternal[f,x] for details.";

MrvLimit::usage=
    "MrvLimit[f,x->lim,options] calculates the limit of f for x approaching \
lim. If MrvLimit succeeds, the limit value will be returned. In  case of \
two-sided limits, a list of two results may be returned, in case that they \
are different. If MrvLimit fails, an error message will be issued, and \
MrvLimit will return the whole call encapsulated in HoldForm. \nPossible \
Options:\n Direction: One of -1, +1, 0 or Automatic. Defaults to Automatic. \
+1 will calculate limits from below, -1 from above, 0 both sided. Automatic \
does both sided limits for finite limit processes, and matching sides for \
infinite.\n Output: Limit, LeadTerm or SignedZero. Default Limit. LeadTerm \
will return a LeadTerm[] object describing the found asymptotic. See LeadTerm \
help. SignedZero will return Zero or -Zero if the limit is 0.\n Debug: \
positive integer n or Automatic. Default Automatic. Enables debugging output \
down to nested level n in recursive calls. Automatic mode will detect \
recursive calls and inherit predecessor's debug level minus 1.";

\!\(\(LeadTerm::usage = \*"\"\<Output->LeadTerm is an option to MrvLimit, to \
return the found asymptotic behavior of the function. To preserve its \
structure, the result will be in internal form, see ToInternal.\\nGeneral \
result form is LeadTerm[c,a], with a of form \
{pwr[\!\(\[Omega]\_1\),\!\(e\_1\)],pwr[\!\(\[Omega]\_2\),\!\(e\_2\)],..}.\\n\!\
\(\[Omega]\_i\) is an asymptotic with \!\(\[Omega]\_i\)\[Rule]0, \!\(\[Omega]\
\_i\)>0 for x\[Rule]\[Infinity]. \!\(e\_i\) is the exponent order of the \
asymptotic, and may be 0. The a list is ordered by dominance, dominating \
asymptotics first. c is the leading term constant.\\nThe general asymptotic \
behavior is c*Apply[Times,a]/.pwr->Power.\>\"";\)\)

MrvLimit::"LimitFail"="Limit failed at `1` on `2`";
MrvLimit::"UnknownSign"="Cannot determine sign: `1`";
MrvLimit::"SeriesFail"="Series failed at `1`";
MrvLimit::"SeriesNoTerms"=
    "Series failed at `1`: No leading term found, possibly undetected Zero \
function";
MrvLimit::"ZeroFunction"="Unexpected Zero function detected.";
MrvLimit::"UnknownOutput"="Unknown output type Output\[Rule]`1`";
MrvLimit::"MrvSetFailed"="MrvSet failed at `1`";
MrvLimit::"UnsupportedFunction"=
    "MrvLimit does not support this function: `1`";
MrvLimit::"UnsupportedArgument"=
    "MrvLimit does not support `1` for `2`, appearing in `3`";
MrvLimit::"RecursiveCall"="Recursive Limit call encountered on `1`";
MrvLimit::"LostContext"=
    "Lost Link to aborted MrvLimit context detected. Skipping.";
MrvLimit::"UnknownOption"="Unknown Option `1`";
MrvLimitInf::"UnknownOption"="Unknown Option `1`";
MrvLimit::"ConditionCheck"="Cannot check important condition `1`";
MrvLimit::"Assert"="Assertion check failed: `1` on `2`";

Begin["`Private`"];



Off[General::spell1];
Off[General::spell];
{Res,ResA,ResB};
On[General::spell1];
On[General::spell];

(* Greetings *)
If[!(MrvLimitLoadSilent===True)
    (*then*),
    Print[
        "MrvLimit v1.0 \[Copyright] 2005 by Udo Richter\n mail: \
udo_richter(at)gmx.de\n web: http://urichter.cjb.net/MrvLimit\n Released \
under the GNU General Public License."];
    ];(* end if *)
 

(* Translate term to internal restricted function space *)

ToInternal[f_,x_]:=f/;FreeQ[f,x];
ToInternal[x_,x_]:=x;
ToInternal[g_*h_,x_]:=ToInternal[g,x]*ToInternal[h,x];
ToInternal[g_+h_,x_]:=ToInternal[g,x]+ToInternal[h,x];
ToInternal[Power[g_,c_],x_]:=
    power[ToInternal[g,x],ToInternal[c,x]]/;FreeQ[c,x];
ToInternal[Power[E,g_],x_]:=power[E,ToInternal[g,x]];
ToInternal[Power[f_,g_],x_]:=power[E,log[ToInternal[f,x]]*ToInternal[g,x]];
ToInternal[Log[g_],x_]:=log[ToInternal[g,x]];

ToInternal[Sin[f_],x_]:=sin[ToInternal[f,x]];
ToInternal[Cos[f_],x_]:=cos[ToInternal[f,x]];
ToInternal[Tan[f_],x_]:=tan[ToInternal[f,x]];
ToInternal[Sec[f_],x_]:=1/cos[ToInternal[f,x]];
ToInternal[Csc[f_],x_]:=1/sin[ToInternal[f,x]];
ToInternal[Cot[f_],x_]:=1/tan[ToInternal[f,x]];

ToInternal[ArcSin[f_],x_]:=arcsin[ToInternal[f,x]];
ToInternal[ArcCos[f_],x_]:=arccos[ToInternal[f,x]];
ToInternal[ArcTan[f_],x_]:=arctan[ToInternal[f,x]];
ToInternal[ArcSec[f_],x_]:=arccos[1/ToInternal[f,x]];
ToInternal[ArcCsc[f_],x_]:=arcsin[1/ToInternal[f,x]];
ToInternal[ArcCot[f_],x_]:=arctan[1/ToInternal[f,x]];

ToInternal[Gamma[f_],x_]:=gamma[ToInternal[f,x]];
ToInternal[LogGamma[f_],x_]:=loggamma[ToInternal[f,x]];
ToInternal[PolyGamma[n_,f_],x_]:=polygamma[n,ToInternal[f,x]];

(* Pass-through if already in internal form: *)
ToInternal[power[f_,g_],x_]:=power[ToInternal[f,x],ToInternal[g,x]];
ToInternal[log[f_],x_]:=log[ToInternal[f,x]];
ToInternal[sin[f_],x_]:=sin[ToInternal[f,x]];
ToInternal[cos[f_],x_]:=cos[ToInternal[f,x]];
ToInternal[tan[f_],x_]:=tan[ToInternal[f,x]];
ToInternal[arcsin[f_],x_]:=arcsin[ToInternal[f,x]];
ToInternal[arccos[f_],x_]:=arccos[ToInternal[f,x]];
ToInternal[arctan[f_],x_]:=arctan[ToInternal[f,x]];
ToInternal[gamma[f_],x_]:=gamma[ToInternal[f,x]];
ToInternal[loggamma[f_],x_]:=loggamma[ToInternal[f,x]];
ToInternal[polygamma[n_,f_],x_]:=polygamma[n,ToInternal[f,x]];

(* Catch all remaining: *)
ToInternal[f_,x_]:=(
      Message[MrvLimit::"UnsupportedFunction",f];
      HoldForm[ToInternal[f,x]]
      );

(* Remove all internal stuff: *)
FromInternal[f_,x_]:=
    f/.{log\[Rule]Log,power\[Rule]Power,sin\[Rule]Sin,cos\[Rule]Cos,
        tan\[Rule]Tan,arcsin\[Rule]ArcSin,arccos\[Rule]ArcCos,
        arctan\[Rule]ArcTan,gamma\[Rule]Gamma,loggamma\[Rule]LogGamma,
        polygamma\[Rule]PolyGamma};

(* Some very basic simplification rules *)
SimpleSimplifications={
      power[z_,0]\[Rule]1,
      power[z_,1]\[Rule]z,
      power[E,log[z_]]\[Rule]z,
      log[power[E,z_]]\[Rule]z,
      power[power[z_,e_],-1]\[Rule]power[z,-e],
      power[-power[z_,e_],-1]\[Rule]-power[z,-e]
      };

(* Display internal functions like public functions *)

log/:MakeBoxes[log[x_],form_]:=MakeBoxes[Log[x],form];
power/:MakeBoxes[power[x_,y_],form_]:=MakeBoxes[Power[x,y],form];

Unprotect[Times];
Times/:MakeBoxes[HoldPattern[Times[t___]],form_]:=Module[{h,i},
        h=HoldComplete[MakeBoxes[Times[t],form]];
        Do[
          If[h[[1,1,i,0]]===power,
              h[[1,1,i,0]]=Power;
              ];(*end if*)
          (*do for*),
          {i,1,Length[{t}]}
          ];
        ReleaseHold[h]
        ]/;MemberQ[{t},power[___]];
Protect[Times];

sin/:MakeBoxes[sin[x_],form_]:=MakeBoxes[Sin[x],form];
cos/:MakeBoxes[cos[x_],form_]:=MakeBoxes[Cos[x],form];
tan/:MakeBoxes[tan[x_],form_]:=MakeBoxes[Tan[x],form];
arcsin/:MakeBoxes[arcsin[x_],form_]:=MakeBoxes[ArcSin[x],form];
arccos/:MakeBoxes[arccos[x_],form_]:=MakeBoxes[ArcCos[x],form];
arctan/:MakeBoxes[arctan[x_],form_]:=MakeBoxes[ArcTan[x],form];
gamma/:MakeBoxes[gamma[x_],form_]:=MakeBoxes[Gamma[x],form];
loggamma/:MakeBoxes[loggamma[x_],form_]:=MakeBoxes[LogGamma[x],form];
polygamma/:MakeBoxes[polygamma[n_,x_],form_]:=MakeBoxes[PolyGamma[n,x],form];

(* General Tools *)

(* Extract context part of module variables *)
GetSymbolModuleContext[a_Symbol]:=Module[{n,p},
      n=SymbolName[Unevaluated[a]];
      p=StringPosition[n,"$"];
      If[p\[Equal]{},"",StringDrop[n,p[[1,1]]-1]]
      ];
SetAttributes[GetSymbolModuleContext,HoldFirst];

(* Extract variable part of module variables *)
GetSymbolModuleName[a_Symbol]:=Module[{n,p},
      n=StringJoin[Context[Unevaluated[a]],SymbolName[Unevaluated[a]]];
      p=StringPosition[n,"$"];
      If[p\[Equal]{},n,StringTake[n,p[[1,1]]-1]]
      ];
SetAttributes[GetSymbolModuleName,HoldFirst];

(* Translate module symbol name to global symbol name *)
Public[a_Symbol]:=Symbol[GetSymbolModuleName[Unevaluated[a]]];
SetAttributes[Public,HoldFirst];

(* Change a symbol's module context to a different one *)
SetModuleContext[a_Symbol,context_]:=
  Symbol[StringJoin[GetSymbolModuleName[Unevaluated[a]],context]]
SetAttributes[SetModuleContext,HoldFirst];


(* Variable options handler *)
(* Handles optional parameters of name\[Rule]value form *)
(* Example: *)
(* MyFunction::"UnknownOption"=                              *)
(*   "MyFunction does not support this option: `1`";         *)
(* Options[MyFunction]={Foo\[Rule]True,Bar\[Rule]False};                 *)
(* MyFunction[Baz_,Options___] := Module[{MyFoo,MyBar},      *)
(*   ReadOptions[MyFunction,{Foo\[Rule]MyFoo,Bar\[Rule]MyBar},Options];  *)
(*   Print["Foo=",MyFoo," Bar=",MyBar];                      *)
(* ];                                                        *)

Clear[ReadOptions];
ReadOptions[Caller_,OptionList_,OptionSeq___]:=Module[{FullOptions,pos},
      (* List of Option,Destination,Default *)
      FullOptions=Map[{#[[1]],Null,#[[2]]}&,Options[Caller]];
      
      (* Add Destinations *)
      Map[
        (FullOptions[[Position[FullOptions,{#[[1]],_,_}][[1,1]],2]]=#[[2]])&
        ,OptionList
        ];
      
      (* Process sequence of options, replace defaults if found *)
      Map[
        (
            If[!MatchQ[#,_\[Rule]_],
                Message[Caller::"UnknownOption",#];
                (*else*),
                pos=Position[FullOptions,{#[[1]],_,_}];
                If[Length[pos]\[Equal]0,
                  Message[Caller::"UnknownOption",#]
                  (*else*),
                  FullOptions[[pos[[1,1]],3]]=#[[2]]
                  ];
                ];
            )&,
        {OptionSeq}
        ];
      
      (* Assign results *)
      Map[(Evaluate[#[[2]]]=#[[3]])&,
        Select[FullOptions,!MatchQ[#,{_,Null,_}]&]];
      ];

(* Remove some options from a sequence of options *)
Clear[DropOptions];
DropOptions[DropOpts_,Options___]:=Module[{opt,i},
      opt={Options};
      Do[
        opt=Select[opt,(!MatchQ[#,DropOpts[[i]]\[Rule]_])&];
        (*do on*),
        {i,1,Length[DropOpts]}
        ];
      Apply[Sequence,opt]
      ];

(* Debug Print function *)
(* IndentPrint allows to indent print output *)

IndentPrint[Spacing_,Text__]:=
    Print[DisplayForm[AdjustmentBox[ToBoxes[SequenceForm[Text]],BoxMargins->
                 {{Spacing,0}, {0, 0}}]]];

(* Interface to set own debug printing routines *)

$DebugPrint=IndentPrint;

(* Interface to modify debug and message output *)

$OutputProcessor=Identity;



(* Global Zero Test code *)

MrvTestZero[term_,x_]:=Simplify[FromInternal[term,x]==0];

$MrvTestZero=MrvTestZero;
(* test if constant is 0 *)

MrvTestZeroInterval[term_,x_\[Rule]\[Infinity]]:=
    Simplify[FromInternal[term,x]==0];

$MrvTestZeroInterval=MrvTestZeroInterval;
(* test if function is identical 0 in interval (x0,\[Infinity]) for some x0. *)
\

(* Sorry, no idea how to check this properly. *)



(* MrvSet is a helper function to calculate the set of most varying sub \
expressions. *)
(* Call MrvSet[f,
      x] with function f in internal representation and variable x. *)

(* Result is a list of MrvF[f,lc,lim] objects. *)
(* f represents one of the most varying sub expressions. f is either x, 
  or of e^_ form. *)
(* lc is LeafCount[f]. *)
(* lim is the limit behavior of f for x\[Rule]\[Infinity]. 
          This can only be +\[Infinity] or 0. *)
(* The resulting list is always sorted by lc, lower (simpler) results first. *)

(* Compare two terms regarding varying class. 
      Optimized for results of MrvSet *)
MrvCompareMrvSet[exp1_,exp2_,x_]:=Module[{l,e1,e2},
      If[exp1===exp2,Return[0]];
      (* This esp. catches exp1=x, exp2=x *)
      
      If[exp1===x ,
        (*then*)
        e1=log[x],
        (*else*)
        If[!MatchQ[exp1,power[E,_]],
          Message[MrvLimit::"Assert","Should be exp:",exp1]];
        e1=exp1[[2]];
        ];
      
      If[exp2===x ,
        (*then*)
        e2=log[x],
        (*else*)
        If[!MatchQ[exp2,power[E,_]],
          Message[MrvLimit::"Assert","Should be exp:",exp2]];
        e2=exp2[[2]];
        ];
      
      (*calculate limit of Log[exp1]/Log[exp2] recursively*)
      l=MrvLimitInf[e1*power[e2,-1],x];
      If[l===Null,
        Message[MrvLimit::"LimitFail",MrvCompareMrvSet,e1/e2];
        Return[Null];
        ];
      If[$MrvTestZero[l,x],Return[1]];
      If[Abs[l]\[Equal]\[Infinity],Return[-1]];
      Return[0];
      ];

(*Calculate union of two MrvSet sets. 
      Drop all elements that are not of max varying class. *)

Clear[MrvSetMax];
MrvSetMax[Set1_,Set2_,x_]:=Module[{l,e1,e2},
      If[Head[Set1]=!=List||Head[Set2]=!=List,
        Return[Null];
        ];
      
      If[Set1==={},Return[Set2]];
      If[Set2==={},Return[Set1]];
      
      (* Now both sets have at least one member *)
      
      Switch[MrvCompareMrvSet[Set1[[1,1]],Set2[[1,1]],x],
        1,Set2,
        -1,Set1,
        0,Sort[Union[Set1,Set2],(#1[[2]]<#2[[2]])&],
        Null,Null (* error indicator *)
        ]
      ];


(* 
  MrvSetRules:
    Apply simple rules to Mrv Set while preserving sort structure etc. 
        Only apply rule sets that dont change the limiting behavior!
  *)

MrvSetRules[MrvF[f_,lc_,lim_],Rules_List]:=Module[{f2},
      (* Apply rule and re-calculate leaf count *)
      f2=f/.Rules;
      MrvF[f2,LeafCount[f2],lim]
      ];

MrvSetRules[S_List,Rules_List]:=
    (* Apply rules and re-sort *)
    
    Sort[
      Map[MrvSetRules[#,Rules]&,S],
      (#1[[2]]<#2[[2]])&
      ];

(* Calculate set of most rapidly varying sub expression, main code *)

Clear[MrvSet];
MrvSet[f_,x_]:={}/;FreeQ[f,x];
MrvSet[x_,x_]:={MrvF[x,1,\[Infinity]]};
MrvSet[g_*h_,x_]:=MrvSetMax[MrvSet[g,x],MrvSet[h,x],x];
MrvSet[g_+h_,x_]:=MrvSetMax[MrvSet[g,x],MrvSet[h,x],x];
MrvSet[power[g_,c_],x_]:=MrvSet[g,x]/;FreeQ[c,x];
MrvSet[log[g_],x_]:=MrvSet[g,x];
MrvSet[power[E,g_],x_]:=Module[{l,m},
      l=MrvLimitInf[g,x];
      If[l\[Equal]Null,
        Message[MrvLimit::"LimitFail","MrvSet",g];
        Return[Null];(* error indicator *)
        ];
      
      If[FreeQ[l,DirectedInfinity],
        (* Seems const. Pass through Mrv set. *)
        Return[MrvSet[g,x]];
        ];
      
      If[l===\[Infinity],
        (* tends to e^\[Infinity]. May contribute to Mrv set *)
        
        m=MrvF[
            power[E,g],
            LeafCount[power[E,g]],
            \[Infinity]
            ];
        Return[MrvSetMax[{m},MrvSet[g,x],x]];
        ]; (* end if l===\[Infinity] *)
      
      
      If[l===-\[Infinity],
        (* tends to e^-\[Infinity]. May contribute to Mrv set *)
        m=MrvF[
            power[E,g],
            LeafCount[power[E,g]],
            0
            ];
        Return[MrvSetMax[{m},MrvSet[g,x],x]];
        ]; (* end if l===-\[Infinity] *)
      
      
      Message[MrvLimit::"UnknownSign",l];
      Return[Null];
      ]; (* end MrvSet[power[E,g_],x_] *)

(* Functions with no essential singularities may pass through: *)
(* Unsupported cases need to be filtered out, of course. *)
MrvSet[sin[f_],x_]:=MrvSet[f,x];
MrvSet[cos[f_],x_]:=MrvSet[f,x];
MrvSet[tan[f_],x_]:=MrvSet[f,x];
MrvSet[arcsin[f_],x_]:=MrvSet[f,x];
MrvSet[arccos[f_],x_]:=MrvSet[f,x];
MrvSet[arctan[f_],x_]:=MrvSet[f,x];
MrvSet[gamma[f_],x_]:=MrvSet[f,x];
MrvSet[loggamma[f_],x_]:=MrvSet[f,x];
MrvSet[polygamma[n_,f_],x_]:=MrvSet[f,x];

(* Catch all remaining *)
MrvSet[f_,x_]:=(
      Message[MrvLimit::"MrvSetFailed",f];
      Null
      );



(* Calculate the complexity of a term *)

Clear[MrvComplexitySet];
MrvComplexitySet[f_,x_]:={}/;FreeQ[f,x];
MrvComplexitySet[x_,x_]:={x};
MrvComplexitySet[g_*h_,x_]:=
    Union[MrvComplexitySet[g,x],MrvComplexitySet[h,x]];
MrvComplexitySet[g_+h_,x_]:=
    Union[MrvComplexitySet[g,x],MrvComplexitySet[h,x]];
MrvComplexitySet[power[g_,c_],x_]:=MrvComplexitySet[g,x]/;FreeQ[c,x];
MrvComplexitySet[log[g_],x_]:=Append[MrvComplexitySet[g,x],log[g]];
MrvComplexitySet[power[E,g_],x_]:=Append[MrvComplexitySet[g,x],power[E,g]];

(* Functions with no essential singularities may pass through: *)
MrvComplexitySet[sin[f_],x_]:=MrvComplexitySet[f,x];
MrvComplexitySet[cos[f_],x_]:=MrvComplexitySet[f,x];
MrvComplexitySet[tan[f_],x_]:=MrvComplexitySet[f,x];
MrvComplexitySet[arcsin[f_],x_]:=MrvComplexitySet[f,x];
MrvComplexitySet[arccos[f_],x_]:=MrvComplexitySet[f,x];
MrvComplexitySet[arctan[f_],x_]:=MrvComplexitySet[f,x];
MrvComplexitySet[gamma[f_],x_]:=MrvComplexitySet[f,x];
MrvComplexitySet[loggamma[f_],x_]:=MrvComplexitySet[f,x];
MrvComplexitySet[polygamma[n_,f_],x_]:=MrvComplexitySet[f,x];

(* catch all remaining *)
MrvComplexitySet[f_,x_]:=(
      Message[MrvLimit::"UnsupportedFunction",f];
      HoldForm[MrvComplexitySet[f,x]]
      );

MrvComplexity[f_,x_]:=Module[{c},
      c=MrvComplexitySet[f,x];
      If[!FreeQ[c,MrvComplexitySet],Return[\[Infinity]]];
      Return[Length[c]];
      ];



(* Calculate head of power series of f, dominant variable \[Omega], 
  secondary variable x. *)
(* log\[Omega] is a replacement term for Log[\[Omega]] and can be substituted \
at any time *)

(* Returns {u,ex} if leading term is u*\[Omega]^ex *)
(* May return u=0 only if f is identical 0. *)


(* SeriesHead *)
(* Tries hard to interprete the output of the Series[] command. *)
(* Returns {c,e} for leading term c*x^e *)

Clear[SeriesHead];
SeriesHead[HoldPattern[SeriesData[x_,0,c_List,nmin_,nmax_,den_]],x_]:=
    If[$MrvTestZero[c[[1]],x],
        SeriesHead[SeriesData[x,0,Drop[c,1],nmin+1,nmax,den]]
        (*else*),
        {c[[1]],nmin/den}
        (*undetermined*),
        {c[[1]],nmin/den}
        ]/;Length[c]>0;

SeriesHead[f_,x_]:={f,0}/;FreeQ[f,x];
SeriesHead[c_.*x_^e_.,x_]:={c,e}/;FreeQ[c,x];&&FreeQ[e,x];
SeriesHead[f_*g_,x_]:=Module[{sf,sg},
      sf=SeriesHead[f,x];
      sg=SeriesHead[g,x];
      If[!FreeQ[sf,SeriesHead]||!FreeQ[sg,SeriesHead],
        Return[sf*sg]
        ];
      Return[{sf[[1]]*sg[[1]],sf[[2]]+sg[[2]]}];
      ];

SeriesHead[f_+g_]:=Module[{sf,sg},
      sf=SeriesHead[f,x];
      sg=SeriesHead[g,x];
      If[!FreeQ[sf,SeriesHead]||!FreeQ[sg,SeriesHead],
        Return[sf+sg]
        ];
      If[sf[[2]]<sg[[2]],Return[sf]];
      If[sf[[2]]>sg[[2]],Return[sg]];
      If[sf[[2]]==sg[[2]],Return[{sf[[1]]+sg[[1]],sf[[2]]}]];
      Return[sf+sg];
      ];


Clear[MrvSeriesHead];
MrvSeriesHead[f_,x_,\[Omega]_,log\[Omega]_,dprint_]:=
    Module[{ser,serh,i,u,ex},
      
      (* Define some local auto simplifications *)
      Unprotect[Log];Unprotect[Power];
      Log[\[Omega]]=FromInternal[log\[Omega],x];
      Log[1/\[Omega]]=-Log[\[Omega]];
      Power[E,Log[\[Omega]]]=\[Omega];
      Power[E,Log[1/\[Omega]]]=1/\[Omega];
      Protect[Log];Protect[Power];
      
      (* Call Series with increasing order to find terms *)
      (* Ugly, but not to avoid. *)
      Do[
        ser=Series[FromInternal[f,x],{\[Omega],0,i}];
        serh=SeriesHead[ser,\[Omega]];
        
        (* check for series term that run out of precision *)
        If[FreeQ[serh,HoldPattern[SeriesData[_,_,{},_,_,_]]],
          (* No: done. *)
          Break[];
          ];
        
        (* Increase precision and continue *)
        
        (* do for *)
        ,{i,1,30}
        ]; (* end do *)
      
      (* Remove local auto simplifications *)
      Unprotect[Log];Unprotect[Power];
      Power[E,Log[\[Omega]]]=.;
      Power[E,Log[1/\[Omega]]]=.;
      Log[\[Omega]]=.;
      Log[1/\[Omega]]=.;
      Protect[Log];Protect[Power];
      
      dprint["Series expansion: ",$OutputProcessor[ser]];
      
      If[!FreeQ[serh,SeriesHead],
        (* SeriesHead could not interprete the result *)
        If[!FreeQ[serh,HoldPattern[SeriesData[_,_,{},_,_,_]]],
          (* No leading terms found *)
          Message[MrvLimit::"SeriesNoTerms",$OutputProcessor[f]];
          Return[Null];
          ];
        Message[MrvLimit::"SeriesFail",$OutputProcessor[f]];
        Return[Null];
        ]; (* end if *)
      
      {u,ex}=serh;
      
      (* Check if Series succeded in eliminating \[Omega] *)
      If[!FreeQ[u,\[Omega]],
        Message[MrvLimit::"SeriesFail",$OutputProcessor[f]];
        Return[Null];
        ];
      
      u=ToInternal[u,x];
      If[!FreeQ[u,ToInternal],
        Return[Null];
        ];
      ex=ToInternal[ex,x];
      If[!FreeQ[ex,ToInternal],
        Return[Null];
        ];
      {u,ex}
      ];  (* end MrvSeriesHead *)

$MrvSeriesHead=MrvSeriesHead;



(* Helper that interprets leading term results *)

MrvLimitLeadTermDominant[asympt_List]:=Module[{i},
      i=1;
      While[i\[LessEqual]Length[asympt] && asympt[[i,2]]\[Equal]0,i++];
      If[i>Length[asympt],Return[Null]];
      Return[i];
      ];

Clear[MrvLimitOutput];
MrvLimitOutput[LeadTerm[const_,asympt_List],Output\[Rule]Limit]:=
    Module[{i,ex},
      i=MrvLimitLeadTermDominant[asympt];
      
      If[i===Null,Return[const]]; (* All exponents are 0, 
        const is the result. *)
      ex=asympt[[i,2]]; (* Exponent of leading term *)
      If[ex>0,Return[0]];(* tends to 0 in all cases *)
      If[ex<0 ,
         (* limit result is +/- \[Infinity] *)
        s=Sign[const];
        If[s===0,
          Message[MrvLimit::"ZeroFunction"];
          Return[Null];
          ];
        Return[s*\[Infinity]]
        ]; (* end if ex<0 *)
      Message[MrvLimit::"UnknownSign",ex];
      ]; (* end MrvLimitOutput *)

MrvLimitOutput[LeadTerm[const_,asympt_List],Output\[Rule]LeadTerm]:=
    LeadTerm[const,asympt];

MrvLimitOutput[LeadTerm[const_,asympt_List],Output\[Rule]SignedZero]:=
    Module[{l},
      l=MrvLimitOutput[LeadTerm[const,asympt],Output\[Rule]Limit];
      If[l===0,Return[Sign[const]*Zero]];
      Return[l];
      ];

(* Mrv limit remember cache *)
MrvLimitClearCache[]:=Module[{},
      Clear[MrvLimitCache];
      MrvLimitCacheHits=0;
      MrvLimitCacheMisses=0;
      ];
MrvLimitClearCache[];
MrvLimitGetCacheStats[]:={CacheHits->MrvLimitCacheHits,
    CacheMisses->MrvLimitCacheMisses}

(* Pre-Processing: 
      Transform expression into processable form and check for limit fail \
conditions. *)

TestLimitArgQ[f_,x_,test_,Undetermined\[Rule]undet_]:=Module[{ff},
      (* test if limit exists and matches a test criteria *)
      ff=MrvLimitInf[f,x];
      If[ff===Null,Return[False]];
      If[test[ff],
        (*then*)
        Return[True];
        ,(*else*)
        Return[False];
        ,(*undetermined*)
        If[undet===True,Return[True]];
        If[undet===False,Return[False]];
        Message[MrvLimit::"ConditionCheck",test[ff]];
        Return[False];
        ];
      ];
TestLimitArgQ[f_,x_,test_]:=TestLimitArgQ[f,x,test,Undetermined\[Rule]-1];

Clear[MrvLimitPreProcess];
MrvLimitPreProcess[f_,x_]:=f/;FreeQ[f,x];
MrvLimitPreProcess[x_,x_]:=x;
MrvLimitPreProcess[g_*h_,x_]:=
    MrvLimitPreProcess[g,x]*MrvLimitPreProcess[h,x];
MrvLimitPreProcess[g_+h_,x_]:=
    MrvLimitPreProcess[g,x]+MrvLimitPreProcess[h,x];
MrvLimitPreProcess[power[g_,c_],x_]:=
    power[MrvLimitPreProcess[g,x],MrvLimitPreProcess[c,x]]/;FreeQ[c,x];
MrvLimitPreProcess[power[E,g_],x_]:=power[E,MrvLimitPreProcess[g,x]];
MrvLimitPreProcess[power[f_,g_],x_]:=
    power[E,log[MrvLimitPreProcess[f,x]]*MrvLimitPreProcess[g,x]];
MrvLimitPreProcess[log[f_],x_]:=log[MrvLimitPreProcess[f,x]];
MrvLimitPreProcess[sin[f_],x_]:=
    If[TestLimitArgQ[f,x,FreeQ[#,DirectedInfinity]&],
      sin[MrvLimitPreProcess[f,x]],
      Message[MrvLimit::"UnsupportedArgument",Sin[x],x\[Rule]\[Infinity],
        Sin[f]];
      HoldForm[MrvLimitPreProcess[sin[f],x]]
      ];
MrvLimitPreProcess[cos[f_],x_]:=
    If[TestLimitArgQ[f,x,FreeQ[#,DirectedInfinity]&],
      cos[MrvLimitPreProcess[f,x]]
      (*else*),
      Message[MrvLimit::"UnsupportedArgument",Cos[x],x\[Rule]\[Infinity],
        Cos[f]];
      HoldForm[MrvLimitPreProcess[cos[f],x]]
      ];
MrvLimitPreProcess[tan[f_],x_]:=
    If[TestLimitArgQ[f,x,FreeQ[#,DirectedInfinity]&],
      tan[MrvLimitPreProcess[f,x]]
      (*else*),
      Message[MrvLimit::"UnsupportedArgument",Tan[x],x\[Rule]\[Infinity],
        Tan[f]];
      HoldForm[MrvLimitPreProcess[tan[f],x]]
      ];
MrvLimitPreProcess[arcsin[f_],x_]:=
    If[TestLimitArgQ[f,x,(Abs[#]\[LessEqual]1)&],
      arcsin[MrvLimitPreProcess[f,x]]
      (*else*),
      Message[MrvLimit::"UnsupportedArgument",ArcSin[x],x\[Rule]\[Infinity],
        ArcSin[f]];
      HoldForm[MrvLimitPreProcess[arcsin[f],x]]
      ];
MrvLimitPreProcess[arccos[f_],x_]:=
    If[TestLimitArgQ[f,x,(Abs[#]\[LessEqual]1)&],
      arccos[MrvLimitPreProcess[f,x]]
      (*else*),
      Message[MrvLimit::"UnsupportedArgument",ArcCos[x],x\[Rule]\[Infinity],
        ArcCos[f]];
      HoldForm[MrvLimitPreProcess[arccos[f],x]]
      ];
MrvLimitPreProcess[arctan[f_],x_]:=If[TestLimitArgQ[f,x,(True)&],
      arctan[MrvLimitPreProcess[f,x]]
      (*else*),
      Message[MrvLimit::"UnsupportedArgument",ArcTan[x],x,ArcTan[f]];
      HoldForm[MrvLimitPreProcess[arctan[f],x]]
      ];
MrvLimitPreProcess[gamma[f_],x_]:=
    If[TestLimitArgQ[f,x,FreeQ[#,DirectedInfinity]&],
      gamma[MrvLimitPreProcess[f,x]]
      (*else*),
      If[TestLimitArgQ[f,x,(#===\[Infinity])&],
        power[E,loggamma[MrvLimitPreProcess[f,x]]]
        (*else*),
        Message[MrvLimit::"UnsupportedArgument",Gamma[x],
          x\[Rule]MrvLimitInf[f,x],Gamma[f]];
        HoldForm[MrvLimitPreProcess[gamma[f],x]]
        ]
      ];

MrvLimitPreProcess[loggamma[f_],x_]:=
    If[TestLimitArgQ[f,x,(0\[LessEqual]#\[LessEqual]\[Infinity])&],
      loggamma[MrvLimitPreProcess[f,x]]
      (*else*),
      Message[MrvLimit::"UnsupportedArgument",LogGamma[x],
        x\[Rule]MrvLimitInf[f,x],LogGamma[f]];
      HoldForm[MrvLimitPreProcess[loggamma[f],x]]
      ];

MrvLimitPreProcess[polygamma[n_,f_],x_]:=Module[{},
      If[!IntegerQ[n]||n<0,
        Message[MrvLimit::"UnsupportedArgument",PolyGamma[k,x],k\[Equal]n,
          PolyGamma[n,f]];
        Return[HoldForm[MrvLimitPreProcess[polygamma[n,f],x]]];
        ];
      If[TestLimitArgQ[f,x,(-\[Infinity]<#\[LessEqual]\[Infinity])&],
        Return[polygamma[n,f]];
        ];
      Message[MrvLimit::"UnsupportedArgument",PolyGamma[n,x],
        x\[Rule]MrvLimitInf[f,x],PolyGamma[n,f]];
      Return[HoldForm[MrvLimitPreProcess[polygamma[n,f],x]]];
      ];

(* catch all remaining *)
MrvLimitPreProcess[f_,x_]:=(
      Message[MrvLimit::"UnsupportedFunction",f];
      HoldForm[MrvLimitPreProcess[f,x]]
      );

(* MrvLimitInf: Main algorithm *)

(* Reset Context links *)
MrvLimitCurrentContext=Null;
Clear[MrvLimitRunningTasks];
MrvLimitDefaultDebugLevel=0;


Clear[MrvLimitInf];
Options[MrvLimitInf]={Output\[Rule]Limit,Debug\[Rule]Automatic};
MrvLimitInf[ff_,x_,Options___]:=Module[
      {\[CapitalOmega],dprint,f,scaleup,w,g,A,s,t,c,a,ex,asympt,i,LastContext,
        NestLevel,DebugLevel,output},
      
      ReadOptions[MrvLimitInf,{Output\[Rule]output,Debug\[Rule]DebugLevel},
        Options];
      
      If[!MemberQ[{Limit,LeadTerm,SignedZero},output],
        Message[MrvLimit::"UnknownOutput", output];
        output=Limit;
        ];
      
      (* Some quick exits for really simple terms *)
      If[FreeQ[ff,x],
        If[output===LeadTerm,Return[LeadTerm[ff,{}]]];
        Return[ff];
        ];
      
      (* Check if previous MrvLimit context is still alive *)
      If[MrvLimitCurrentContext=!=Null,
        If[!NameQ[
                StringJoin[GetSymbolModuleName[LastContext],
                  MrvLimitCurrentContext]],
            (* Last context died unexpected. *)
            Message[MrvLimit::"LostContext"];
            MrvLimitCurrentContext=Null;
            Clear[MrvLimitRunningTasks];
            ];
        ]; (* end if *)
      
      (* Connect to last context if present. *)
      (* From here on, clean exit code is requred. *)
      LastContext=MrvLimitCurrentContext;
      MrvLimitCurrentContext=GetSymbolModuleContext[LastContext];
      
      Catch[
          (* 
            Catch/Throw error handling from here. 
                Throw[] uses clean exit code. *)
          
          (* Get MrvLimit nest level *)
          
          NestLevel=
            If[LastContext===Null,1,
              SetModuleContext[NestLevel,LastContext]+1];
          
          (* Get Debug level *)
          If[DebugLevel===Automatic,
            
            DebugLevel=
                If[LastContext===Null,MrvLimitDefaultDebugLevel,
                  SetModuleContext[DebugLevel,LastContext]];
            ];
          
          
          (* Prepare dprint based on DebugLevel *)
          If[DebugLevel\[GreaterEqual]NestLevel
            (*then*),
            dprint[s__]:=$DebugPrint[NestLevel-1,s];
            
            dprint["Enter Level ",NestLevel,
              " Call ",$OutputProcessor[
                HoldForm[MrvLimitInf[ff,x,Options]]]];
            (*else*),
            dprint[s__]=Null;
            ];(*end if*)
          SetAttributes[dprint,HoldAll];
          
          (* Check for cached result *)
          asympt=MrvLimitCache[ff];
          If[Head[asympt]=!=MrvLimitCache,
            (*found in cache*)
            
            MrvLimitCacheHits++;
            dprint["Taking cached result"];
            
            Throw[MrvLimitOutput[asympt,Output\[Rule]output]];
            
            (*else if Length[i]>0*),
            MrvLimitCacheMisses++;
            ]; (* end if Length[i]>0 *)
          
          (* Check for recursive calls *)
          If[MrvLimitRunningTasks[ff],
            Message[MrvLimit::"RecursiveCall",ff];
            Return[Null];
            ];
          
          (* Mark this task 'in progress' for recursive call checking *)
          MrvLimitRunningTasks[ff]=True;
          
          
          (*************************************)
          (* Ok, lets start with the real work *)
          (*************************************)
          
          f=ff;
          If[$MrvTestZeroInterval[f,x\[Rule]\[Infinity]],
            (* 
              Function is identical 0 around \[Infinity]. 
                    Dont start to calculate crap with it... *)
            Throw[0];
            ];
          
          asympt={};
          (* Result is f*Apply[Times,asympt]/.pwr\[Rule]Power , 
            while asympt is a dominance ordered list of pwr[w,ex], 
            w tends to 0 for x\[Rule]0.
            *)
          
          While[!FreeQ[f,x],
            (* While f depends on x: Do Mrv limit calculation *)
            
            dprint["Calculating limit of ",$OutputProcessor[f]];
            
            (* First, do pre-processing for some functions *)
            f=MrvLimitPreProcess[f,x];
            If[!FreeQ[f,MrvLimitPreProcess],
              dprint["Pre Processing failed  :",$OutputProcessor[f]];
              Throw[Null];
              ];
            
            (* Now do 'simple simplifications' *)
            f=f/.SimpleSimplifications;
            
            (* Calculate Mrv set *)
            dprint["Calculating Mrv set of ",$OutputProcessor[f]];
            \[CapitalOmega]=MrvSet[f,x];
            If[\[CapitalOmega]===Null,Throw[Null]];
            If[\[CapitalOmega]==={},
              Message[MrvLimit::"MrvSetFailed",$OutputProcessor[f]];
              Throw[Null];
              ];
            dprint["\[CapitalOmega]=",$OutputProcessor[\[CapitalOmega]]];
            
            (* Scale up? *)
            scaleup=0;
            While[\[CapitalOmega][[1,1]]===x,
              (* x, if present in \[CapitalOmega], 
                will always be the first one *)
              scaleup++;
              f=f/.{log[x]\[Rule]x,x\[Rule]power[E,x]};
              \[CapitalOmega]=
                MrvSetRules[\[CapitalOmega],{log[x]\[Rule]x,
                    x\[Rule]power[E,x]}];
              
              (* 
                in f and \[CapitalOmega], 
                all occurences of e^x got replaced the same way. also, 
                all inner occurences of log[x] got replaced the same way. 
                    Only problem: 
                    The x in \[CapitalOmega] may have been present in f as \
log[x], transforming x\[Rule]e^x in \[CapitalOmega] and log[x]\[Rule]x in f. 
                        But since all members of \[CapitalOmega] now have \
comparability class e^x, 
                this x term is of lower class. 
                    But if none of the terms in \[CapitalOmega] is left in f \
(all occurences of x in f were log[x]), 
                then there is no term of e^x order in f, 
                and we have to search again for the next lower class.
                *)
              
              \[CapitalOmega]=Select[\[CapitalOmega],!FreeQ[f,#[[1]]]&];
              (* eliminate non-occuring terms *)
              
              If[\[CapitalOmega]==={},\[CapitalOmega]=MrvSet[f,x]];
              (* If all eliminated, scan for next lower class *)
              
              
              dprint["Scale Up: f=",$OutputProcessor[f],"\n",
                "\[CapitalOmega]=",$OutputProcessor[\[CapitalOmega]]];
              ];
            
            (* All Mrv's must be of e^_ form. Assert if not. *)
            If[!Apply[And,Map[MatchQ[#[[1]],power[E,_]]&,\[CapitalOmega]]],
              
              Message[MrvLimit::"Assert",
                "\[CapitalOmega] non-exponential",\[CapitalOmega]];
              Throw[Null];
              ];
            
            (* \[Omega] is the first one *)
            w=\[CapitalOmega][[1,1]];
            
            dprint["\[Omega]=",$OutputProcessor[w]];
            
            (* We need \[Omega]\[Rule]0. If \[Omega]\[Rule]\[Infinity], 
              substitute. *)
            (* We know, \[Omega] is of e^f_ form *)
            
            If[\[CapitalOmega][[1,3]]===\[Infinity],
              (* 
                w\[Rule]\[Infinity]. 
                        Turn around sign inside e^_ to get w\[Rule]0 *)
              w[[2]]=-w[[2]];
              
              dprint["Replacing \[Omega]\[Rule]1/\[Omega]: \
\[Omega]=",$OutputProcessor[w]];
              ];
            
            (* replace to \[Omega] in f step by step *)
            Do[
              g=\[CapitalOmega][[i,1]]; 
              (* Substitute all occurences of this subexpr *)
              (* see chapter 4.8 or Lemma 3.18 [Gru96] for details *)
              
              dprint["Prepare to rewrite g=",$OutputProcessor[g],
                " to A*\[Omega]^c"];
              
              c=FromInternal[g[[2]]/w[[2]],x];
              (* We'll take some auto-optimizations for this *)
              c=ToInternal[c,x];
              If[!FreeQ[c,ToInternal],
                c=Null;
                ];
              (* Now fine again *)
              
              c=MrvLimitInf[c,x];
              If[c===Null || c===0 || !FreeQ[c,DirectedInfinity],
                
                Message[MrvLimit::"LimitFail","MrvLimit rewrite",
                  g[[2]]/w[[2]]];
                Throw[Null]
                ];
              
              A=power[E,g[[2]]-c w[[2]]]//.SimpleSimplifications;
              
              dprint["c=",$OutputProcessor[c]," A=",$OutputProcessor[A]];
              
              f=f/.{g\[Rule]A*power[\[Omega],c]}; (* and replace. *)
              
              dprint[
                "Rewriting ",$OutputProcessor[g],
                "\[Rule]",$OutputProcessor[A*power[\[Omega],c]],
                "\n","f=",$OutputProcessor[f]
                ];
              
              (*do for*)
              ,{i,Length[\[CapitalOmega]],1,-1}
              ]; (* end do *)
            
            (* Done rewriting *)
            
            dprint["Calculating power series: f=",$OutputProcessor[f]];
            
            (* Calculate power series head *)
            ser=$MrvSeriesHead[f,x,\[Omega],w[[2]],dprint];
            
            If[ser===Null,Throw[Null]];
            {f,ex}=ser;
            
            While[scaleup>0,
              scaleup--;
              f=f/.{power[E,x]\[Rule]x,x\[Rule]log[x]};
              w=w/.{power[E,x]\[Rule]x,x\[Rule]log[x]};
              
              dprint["Scale Down: f=",$OutputProcessor[f],
                " , \[Omega]=",$OutputProcessor[w]];
              ];
            
            
            dprint["Dominant term: ",$OutputProcessor[f*power[\[Omega],ex]],
              " , \[Omega]=",$OutputProcessor[w]];
            
            If[$MrvTestZeroInterval[f,x\[Rule]\[Infinity]],
              (* This explicitly means that f has been identical zero *) (* 
                for x\[Rule]\[Infinity] when entering this loop. 
                      This is fatal, *)
              (* since this should have been detected before entering *)
              (* the loop, or while in the previous loop run. *)
              (* Either the function was identical 0 from the beginning, *)
              (* or one of the series heads returned has been identical 0 *)
              (* without detecting it. Either way, we failed miserably. *)
              
              Message[MrvLimit::"ZeroFunction"];
              Throw[Null];
              ];
            
            AppendTo[asympt,pwr[w,ex]];
            
            (* End of this limit round. Continue on lower Mrv level? *)
            ]; (* While !FreeQ[f,x] *)
          
          
          
          (* Result is f*Apply[Times,asympt]/.pwr\[Rule]Power , 
            while asympt is a dominance ordered list of pwr[w,ex], 
            w tends to 0 for x\[Rule]0 
            *)
          
          
          dprint["Dominant asymptotic: ",$OutputProcessor[f],
            Apply[Sequence,$OutputProcessor[asympt/.pwr\[Rule]power]]];
          
          
          (* Add this result to cache *)
          MrvLimitCache[ff]=LeadTerm[f,asympt];
          
          Throw[MrvLimitOutput[LeadTerm[f,asympt],Output\[Rule]output]];
          
          (* end Catch *)
          ] // (
            (*Begin pure function*)
            (* Exit code *)
            
            (* Clear 'in progress' state *)
            If[MrvLimitRunningTasks[ff],MrvLimitRunningTasks[ff]=.];
            
            
            dprint["Leave Level ",NestLevel,
              " Call ",$OutputProcessor[
                HoldForm[MrvLimitInf[ff,x,Options]\[Equal]#]]];
            
            MrvLimitCurrentContext=LastContext;
            
            # (* Pass through result *)
            )& (* end pure function *)
      ];(* end MrvLimitInf *)

(* force cache clear on code change *)
MrvLimitClearCache[];

(* MrvLimit interface code *)

Clear[MrvLimit];
Options[MrvLimit]={Output\[Rule]Limit,Debug\[Rule]Automatic,
      Direction\[Rule]Automatic,ClearCache\[Rule]False};
MrvLimit[ff_,x_\[Rule]lim_,Options___]:=
    Module[{Res,ResA,ResB,f,z,direction,lim1,ChildOptions,clearcache},
      ReadOptions[
        MrvLimit,{Direction\[Rule]direction,ClearCache\[Rule]clearcache},
        Options];
      
      (* Remove Direction\[Rule] and ClearCache\[Rule] options *)
      ChildOptions=DropOptions[{Direction,ClearCache},Options];
      
      If[clearcache,
        MrvLimitClearCache[];
        ];
      
      (* Delete lost contexts *)
      MrvLimitCurrentContext=Null;
      Clear[MrvLimitRunningTasks];
      
      f=ToInternal[ff,x];
      If[!FreeQ[f,ToInternal],
        Return[HoldForm[MrvLimit[ff,x\[Rule]lim,Options]]];
        ];
      
      lim1=lim;
      If[direction===Automatic,
        (* Set auto direction *)
        Which[
            Head[lim]===Global`SuperPlus,(direction=-1;lim1=lim[[1]]),
            Head[lim]===Global`SuperMinus,(direction=1;lim1=lim[[1]]),
            (* 
              hell knows why I have to explicitly request global context. 
                  Wont work otherwise.*)
            lim===\[Infinity],direction=1,
            lim===-\[Infinity],direction=-1,
            True,direction=0
            ];
        ];
      
      If[direction\[LessEqual]0,
        (* limit from above *)
        If[Abs[lim1]\[Equal]\[Infinity],
          ResA=MrvLimitInf[f/.x\[Rule]-x,x,ChildOptions];
          ResA=ResA/.{x\[Rule]-x};
          (* else *),
          ResA=MrvLimitInf[
              f/.{x\[Rule]power[x,-1]+lim1}//.SimpleSimplifications
              ,x,ChildOptions];
          ResA=ResA/.{x\[Rule]power[x-lim1,-1]}//.SimpleSimplifications;
          ];
        
        If[ ResA===Null,Return[HoldForm[MrvLimit[ff,x\[Rule]lim,Options]]]];
        ];
      If[direction\[GreaterEqual]0,
        (* limit from below *)
        If[Abs[lim1]\[Equal]\[Infinity],
          ResB=MrvLimitInf[f,x,ChildOptions];
          (* else *),
          ResB=MrvLimitInf[
              f/.{x\[Rule]-power[x,-1]+lim1}//.SimpleSimplifications
              ,x,ChildOptions];
          ResB=ResB/.{x\[Rule]power[lim1-x,-1]}//.SimpleSimplifications;
          ];
        
        If[ ResB===Null,Return[HoldForm[MrvLimit[ff,x\[Rule]lim,Options]]]];
        ];
      
      (* Final result processing depending on direction *)
      
      If[direction\[Equal]0,
        (* two sided limit, check continuity *)
        If[ResA===ResB ,
            Res=ResA;
            , (* else *)
            Res={ResB,ResA};
            ];
        ];
      If[direction<0,
        Res=ResA;
        ];
      If[direction>0,
        Res=ResB;
        ];
      
      If[Head[Res]=!=LeadTerm,Res=FromInternal[Res,x]];
      
      Res
      ]; (*end MrvLimit*)


End[];
EndPackage[];